import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpentelekomcloudAntiddosV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/antiddos_v1#floating_ip_address DataOpentelekomcloudAntiddosV1#floating_ip_address}
    */
    readonly floatingIpAddress?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/antiddos_v1#floating_ip_id DataOpentelekomcloudAntiddosV1#floating_ip_id}
    */
    readonly floatingIpId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/antiddos_v1#region DataOpentelekomcloudAntiddosV1#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/antiddos_v1#status DataOpentelekomcloudAntiddosV1#status}
    */
    readonly status?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/antiddos_v1 opentelekomcloud_antiddos_v1}
*/
export declare class DataOpentelekomcloudAntiddosV1 extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/antiddos_v1 opentelekomcloud_antiddos_v1} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpentelekomcloudAntiddosV1Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudAntiddosV1Config);
    get bpsAttack(): number[];
    get bpsIn(): number[];
    get endTime(): number[];
    private _floatingIpAddress?;
    get floatingIpAddress(): string;
    set floatingIpAddress(value: string);
    resetFloatingIpAddress(): void;
    get floatingIpAddressInput(): string | undefined;
    private _floatingIpId?;
    get floatingIpId(): string;
    set floatingIpId(value: string);
    resetFloatingIpId(): void;
    get floatingIpIdInput(): string | undefined;
    get id(): string;
    get networkType(): string;
    get periodStart(): number[];
    get ppsAttack(): number[];
    get ppsIn(): number[];
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get startTime(): number[];
    private _status?;
    get status(): string;
    set status(value: string);
    resetStatus(): void;
    get statusInput(): string | undefined;
    get totalBps(): number[];
    get totalPps(): number[];
    get trafficCleaningStatus(): number[];
    get triggerBps(): number[];
    get triggerHttpPps(): number[];
    get triggerPps(): number[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
