import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpentelekomcloudCtsTrackerV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#bucket_name DataOpentelekomcloudCtsTrackerV1#bucket_name}
    */
    readonly bucketName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#file_prefix_name DataOpentelekomcloudCtsTrackerV1#file_prefix_name}
    */
    readonly filePrefixName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#project_name DataOpentelekomcloudCtsTrackerV1#project_name}
    */
    readonly projectName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#region DataOpentelekomcloudCtsTrackerV1#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#status DataOpentelekomcloudCtsTrackerV1#status}
    */
    readonly status?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#tracker_name DataOpentelekomcloudCtsTrackerV1#tracker_name}
    */
    readonly trackerName?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1 opentelekomcloud_cts_tracker_v1}
*/
export declare class DataOpentelekomcloudCtsTrackerV1 extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1 opentelekomcloud_cts_tracker_v1} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpentelekomcloudCtsTrackerV1Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudCtsTrackerV1Config);
    private _bucketName?;
    get bucketName(): string;
    set bucketName(value: string);
    resetBucketName(): void;
    get bucketNameInput(): string | undefined;
    private _filePrefixName?;
    get filePrefixName(): string;
    set filePrefixName(value: string);
    resetFilePrefixName(): void;
    get filePrefixNameInput(): string | undefined;
    get id(): string;
    get isSendAllKeyOperation(): cdktf.IResolvable;
    get isSupportSmn(): cdktf.IResolvable;
    get needNotifyUserList(): string[];
    get operations(): string[];
    private _projectName?;
    get projectName(): string;
    set projectName(value: string);
    resetProjectName(): void;
    get projectNameInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _status?;
    get status(): string;
    set status(value: string);
    resetStatus(): void;
    get statusInput(): string | undefined;
    get topicId(): string;
    private _trackerName?;
    get trackerName(): string;
    set trackerName(value: string);
    resetTrackerName(): void;
    get trackerNameInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
