import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpentelekomcloudLbFlavorV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_flavor_v3#name DataOpentelekomcloudLbFlavorV3#name}
    */
    readonly name?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_flavor_v3 opentelekomcloud_lb_flavor_v3}
*/
export declare class DataOpentelekomcloudLbFlavorV3 extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_flavor_v3 opentelekomcloud_lb_flavor_v3} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpentelekomcloudLbFlavorV3Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudLbFlavorV3Config);
    get bandwidth(): number;
    get cps(): number;
    get id(): string;
    get maxConnections(): number;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get qps(): number;
    get shared(): cdktf.IResolvable;
    get type(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
