import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpentelekomcloudRdsFlavorsV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v3#db_type DataOpentelekomcloudRdsFlavorsV3#db_type}
    */
    readonly dbType: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v3#db_version DataOpentelekomcloudRdsFlavorsV3#db_version}
    */
    readonly dbVersion: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v3#instance_mode DataOpentelekomcloudRdsFlavorsV3#instance_mode}
    */
    readonly instanceMode: string;
}
export declare class DataOpentelekomcloudRdsFlavorsV3Flavors extends cdktf.ComplexComputedList {
    get azStatus(): {
        [key: string]: string;
    };
    get memory(): number;
    get mode(): string;
    get name(): string;
    get vcpus(): string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v3 opentelekomcloud_rds_flavors_v3}
*/
export declare class DataOpentelekomcloudRdsFlavorsV3 extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v3 opentelekomcloud_rds_flavors_v3} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpentelekomcloudRdsFlavorsV3Config
    */
    constructor(scope: Construct, id: string, config: DataOpentelekomcloudRdsFlavorsV3Config);
    private _dbType?;
    get dbType(): string;
    set dbType(value: string);
    get dbTypeInput(): string | undefined;
    private _dbVersion?;
    get dbVersion(): string;
    set dbVersion(value: string);
    get dbVersionInput(): string | undefined;
    flavors(index: string): DataOpentelekomcloudRdsFlavorsV3Flavors;
    get id(): string;
    private _instanceMode?;
    get instanceMode(): string;
    set instanceMode(value: string);
    get instanceModeInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
