import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpentelekomcloudSfsTurboShareV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sfs_turbo_share_v1#name DataOpentelekomcloudSfsTurboShareV1#name}
    */
    readonly name: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sfs_turbo_share_v1 opentelekomcloud_sfs_turbo_share_v1}
*/
export declare class DataOpentelekomcloudSfsTurboShareV1 extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sfs_turbo_share_v1 opentelekomcloud_sfs_turbo_share_v1} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpentelekomcloudSfsTurboShareV1Config
    */
    constructor(scope: Construct, id: string, config: DataOpentelekomcloudSfsTurboShareV1Config);
    get availabilityZone(): string;
    get availableCapacity(): string;
    get cryptKeyId(): string;
    get exportLocation(): string;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get region(): string;
    get securityGroupId(): string;
    get shareProto(): string;
    get shareType(): string;
    get size(): number;
    get subnetId(): string;
    get version(): string;
    get vpcId(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
