import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface WafCcattackprotectionRuleV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#action_category WafCcattackprotectionRuleV1#action_category}
    */
    readonly actionCategory: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#block_content WafCcattackprotectionRuleV1#block_content}
    */
    readonly blockContent?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#block_content_type WafCcattackprotectionRuleV1#block_content_type}
    */
    readonly blockContentType?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#limit_num WafCcattackprotectionRuleV1#limit_num}
    */
    readonly limitNum: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#limit_period WafCcattackprotectionRuleV1#limit_period}
    */
    readonly limitPeriod: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#lock_time WafCcattackprotectionRuleV1#lock_time}
    */
    readonly lockTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#policy_id WafCcattackprotectionRuleV1#policy_id}
    */
    readonly policyId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#tag_category WafCcattackprotectionRuleV1#tag_category}
    */
    readonly tagCategory?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#tag_contents WafCcattackprotectionRuleV1#tag_contents}
    */
    readonly tagContents?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#tag_index WafCcattackprotectionRuleV1#tag_index}
    */
    readonly tagIndex?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#tag_type WafCcattackprotectionRuleV1#tag_type}
    */
    readonly tagType: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#url WafCcattackprotectionRuleV1#url}
    */
    readonly url: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#timeouts WafCcattackprotectionRuleV1#timeouts}
    */
    readonly timeouts?: WafCcattackprotectionRuleV1Timeouts;
}
export interface WafCcattackprotectionRuleV1Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#create WafCcattackprotectionRuleV1#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#delete WafCcattackprotectionRuleV1#delete}
    */
    readonly delete?: string;
}
export declare function wafCcattackprotectionRuleV1TimeoutsToTerraform(struct?: WafCcattackprotectionRuleV1TimeoutsOutputReference | WafCcattackprotectionRuleV1Timeouts | cdktf.IResolvable): any;
export declare class WafCcattackprotectionRuleV1TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): WafCcattackprotectionRuleV1Timeouts | undefined;
    set internalValue(value: WafCcattackprotectionRuleV1Timeouts | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1 opentelekomcloud_waf_ccattackprotection_rule_v1}
*/
export declare class WafCcattackprotectionRuleV1 extends cdktf.TerraformResource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1 opentelekomcloud_waf_ccattackprotection_rule_v1} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options WafCcattackprotectionRuleV1Config
    */
    constructor(scope: Construct, id: string, config: WafCcattackprotectionRuleV1Config);
    private _actionCategory?;
    get actionCategory(): string;
    set actionCategory(value: string);
    get actionCategoryInput(): string | undefined;
    private _blockContent?;
    get blockContent(): string;
    set blockContent(value: string);
    resetBlockContent(): void;
    get blockContentInput(): string | undefined;
    private _blockContentType?;
    get blockContentType(): string;
    set blockContentType(value: string);
    resetBlockContentType(): void;
    get blockContentTypeInput(): string | undefined;
    get default(): cdktf.IResolvable;
    get id(): string;
    private _limitNum?;
    get limitNum(): number;
    set limitNum(value: number);
    get limitNumInput(): number | undefined;
    private _limitPeriod?;
    get limitPeriod(): number;
    set limitPeriod(value: number);
    get limitPeriodInput(): number | undefined;
    private _lockTime?;
    get lockTime(): number;
    set lockTime(value: number);
    resetLockTime(): void;
    get lockTimeInput(): number | undefined;
    private _policyId?;
    get policyId(): string;
    set policyId(value: string);
    get policyIdInput(): string | undefined;
    private _tagCategory?;
    get tagCategory(): string;
    set tagCategory(value: string);
    resetTagCategory(): void;
    get tagCategoryInput(): string | undefined;
    private _tagContents?;
    get tagContents(): string[];
    set tagContents(value: string[]);
    resetTagContents(): void;
    get tagContentsInput(): string[] | undefined;
    private _tagIndex?;
    get tagIndex(): string;
    set tagIndex(value: string);
    resetTagIndex(): void;
    get tagIndexInput(): string | undefined;
    private _tagType?;
    get tagType(): string;
    set tagType(value: string);
    get tagTypeInput(): string | undefined;
    private _url?;
    get url(): string;
    set url(value: string);
    get urlInput(): string | undefined;
    private _timeouts;
    get timeouts(): WafCcattackprotectionRuleV1TimeoutsOutputReference;
    putTimeouts(value: WafCcattackprotectionRuleV1Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): WafCcattackprotectionRuleV1Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
